

	;Shifts the stream in the IStr register by the amount
	;given in R8. Uses the Res register as bit Reservoar,
	;Res_Count indicates the number of bits left in the
	;Reservoar

.start_profile shift_istream
shift_istream:
	sub		R8, Res_Count
	bra.n   get_packet
	str     R8, IStr
	sll     R8, Res
	ret
.end_profile shift_istream
get_packet:
	add		R8, Res_Count
	str		Res_Count, IStr
	ld.w	[IStr_Addr]+, Res
	sub     Res_Count, R8
	mov		0x10, Res_Count
	bra		shift_istream	
	


;shift_istream:
;	sub		R8, Res_Count					;Check if there is enough bits left in R_Res
;	bra.n	get_packet					
;	movbf   Res[15:R8], R12  		    ;Extract bits R_Res
;	sll		R8, Res					;Shift out bits from R_Res
;	sll     R8, IStr					;Make room in R_IStr for bits from R_Res
;	or      R12, IStr					;Mask in bits in R_IStr from R_Res
;	ret									;Return from call
;get_packet:
;	add 	R8, Res_Count					;Calculate bits left in R_Res
;	movbf   Res[15:Res_Count], R12		;Extract the remaining bits from R_Res
;	sll		Res_Count, IStr				;Make room in R_IStr for bits from R_Res 
;	or		R12, IStr					;Mask in remaining bits
;	ld.w	[IStr_Addr]+, Res		;Load new bits to R_Res
;	sub		Res_Count,	R8				;Calculate bits left to stream in to R_Istr
;	mov		0x10,	Res_Count				;Reset R_Count to 16
;	bra		shift_istream 
	
	

;---------------------------------------------------------------------------------	
	
.start_profile decode	
dec_stream:
	movbf	IStr[14:2],	R6[1]
	cmp	3,		R6
	bra.eq	char	
	cmp	0,		R6
	bra.eq	len_2_bit
	cmp	1,		R6
	bra.eq	len_4_bit
	cmp	2,		R6
	bra.eq	len_7_bit
char:
	tst	0x8000,		IStr
	bra.eq	finish
	movbf	IStr[12:8],	R6[7]
	st.b	R6,		[OUT_PTR]+	
	mov 	11,		R8
	call	shift_istream
	bra	end_dec
len_2_bit
	movbf	IStr[12:2],	R6[1]
	add	3,		R6
	mov 	5,		R8
	bra dist
len_4_bit
	movbf	IStr[12:4],	R6[3]
	add	7,		R6
	mov	7,		R8
	bra	dist
len_7_bit
	movbf	IStr[12:7],	R6[6]
	add	23,		R6
	mov	10,		R8
dist
	tst	0x8000,		IStr
	bra.ne	dist_10_bit
	call	shift_istream
	slr	8,		IStr,	R11
	mov	8,		R8
	bra	cont_dist
dist_10_bit
	call	shift_istream
	slr	6,		IStr,	R11
	mov	10,		R8
cont_dist:
	call	shift_istream
	sub	R11,		OUT_PTR,R11
	
dec_loop:
	ld.b	[R11]+,		R12
	sub	1,		R6
	st.b	R12,		[OUT_PTR]+
	bra.ne 	dec_loop
end_dec:
	ret
.end_profile decode

 
	
	
		
	
	