	;Bit count OS_BCOUNT, data R7, size R8

.start_profile shift_ostream streams
shift_ostream:
	ror		R8,			R7
	sub     R8,			OS_BCOUNT
	bra.n	store_ostream
	str		R8,			OUT_REG
return_stream:
	ret
.end_profile shift_ostream
store_ostream
	add		R8,			OS_BCOUNT
	str		OS_BCOUNT,	OUT_REG
	st.w	OUT_REG,	[OUT_PTR]+
	sll		OS_BCOUNT,  R7
	sub		OS_BCOUNT,	R8
	str		R8,	OUT_REG
	mov		0x10,		OS_BCOUNT
	sub		R8,			OS_BCOUNT
	bra     return_stream

	
				
	
;.start_profile shift_ostream streams
;shift_ostream
;	sub 	R8, 		OS_BCOUNT		;Check if there is room for incomming bits
;	bra.n 	store_OStr				;If not, store packet
;	sll 	R8, 		OUT_REG			;Make room for incomming bits
;	or 	R7, 		OUT_REG			;Mask in bits
;ret_shift_ostream:
;	ret
;.end_profile shift_ostream
;store_OStr
;	add	R8,		OS_BCOUNT		;Calc room left
;	ror	R8,		R7,	R12
;	movbf   R12[15:OS_BCOUNT], R12
;	sll    OS_BCOUNT,   OUT_REG
;	or     R12,  OUT_REG
;	st.w	OUT_REG,		[OUT_PTR]+
;	mov	R7,		OUT_REG
;	sub	OS_BCOUNT,	R8
;	mov	0x10,		OS_BCOUNT
;	sub	R8,		OS_BCOUNT
;	bra ret_shift_ostream
;	;ret
;----------------------------------------------------------------------

.start_profile crc1
crc1:	
	;mov 	0x3, 		R10
	ld.b 	[R7]+, 		R12
	xor 	R11, 		R11			
	crc     R12,        R11
	ld.b    [R7]+,      R12
	ld.b    [R7]+,      R10
	crc     R12,        R11
	crc     R10,        R11
	slr	    8,     R11
	ret
;crc_loop:
;	xor 	R12, 		R11
;	ldin 	[R11*+LUT], 	R11
;	ld.b 	[R7]+, 		R12
;	sub 	1, 		R10
;	bra.ne 	crc_loop
;	ret
.end_profile crc1



.start_profile control_match	
check_match:
	xor 	R9, 		R9			;clear count reg
check_match_loop:
	add 	0x1, 		R9			;Increment
	ld.b 	[R7]+, 		R10			;load from look-ahead buffer
	ld.b 	[R8]+, 		R11			;load from search buffer (match)
	cmp	150,		R9
	bra.eq	finish_check_match
	cmp	END_INN_STREAM,	R7
	bra.eq 	finish_check_match
	cmp	STREAM_PTR,	R8
	bra.eq 	finish_check_match
	cmp 	R10, 		R11			;If equal
	bra.eq 	check_match_loop
finish_check_match:
	sub 	0x1, 		R9			;Subtract one
	ret
.end_profile control_match
	
	
.start_profile add_match	
add_match:
	ldin	[R9*+HASH_TABLE],R10
	stin	R8,		[R9*+HASH_TABLE]
	st.w 	R7, 		[R8]+
	st.w 	R10, 		[R8]+
	ret
.end_profile add_match
	

	
.start_profile make_code
enc_stream:
	
	tst 0xFFFF, R6			;If count is zero, no match found
	bra.ne length
	
new_char:
	ld.b [STREAM_PTR], R5
	mov 	11,	R8
	or 	0x0700, R5,	R7
	bra end_enc_stream

length:
	mov	R6,	R7
	sub	R5,	STREAM_PTR, R11
	cmp	256,	R11
	bra.ges	add_pre_dist_10_bit
	xor	R10,	R10
cont_length:
	cmp	7,	R6
	bra.n	length_2_bit
	cmp	23,	R6
	bra.n	length_4_bit
	sub	23,	R7
	or	0x2,	R10
	insbf	R10[2:3],	R7[9]
	mov	10,	R8
	bra	dist
length_2_bit
	sub	3,	R7
	insbf	R10[2:3],	R7[4]
	mov	5,	R8
	bra	dist
length_4_bit
	sub	7,	R7
	or	1,	R10
	insbf	R10[2:3],	R7[6]
	mov	7,	R8
dist:
	call	shift_ostream	 
	mov	R11,	R7
	cmp	256,	R7
	bra.n	dist_8_bit
	mov	10,	R8
	bra 	end_enc_stream
dist_8_bit
	mov	8,	R8
end_enc_stream:
	call 	shift_ostream
	add	1,	STREAM_PTR
	ret	
.end_profile make_code
	
add_pre_dist_10_bit:
	mov	4,	R10
	bra 	cont_length
		

	


	
	
	
	
	
	