ISTREAM		.ASSIGN 0		;0x0000
OSTREAM		.ASSIGN 5120		;0x0100
STACK_POINTER	.ASSIGN 8192		;0x0400
ROOT_ADDR	.ASSIGN 1024		;0x0400
TABLE_ADDR	.ASSIGN 4096		;0x1000

RIGHT_LEAF	.ASSIGN 2560		;0x0A00
LEFT_LEAF	.ASSIGN 3072		;0x0C00
RIGHT_INT	.ASSIGN 512		;0x0200
LEFT_INT	.ASSIGN 1024		;0x0400
LEAF		.ASSIGN 2048		;0x0800
INT		.ASSIGN 2047		;0x07FF
ADDR_MASK	.ASSIGN 511		;0x01FF
DEL_ADDR_MASK	.ASSIGN 65024		;0xFE00



IStr_Addr 	.ASSIGN R0
OStr_Addr 	.ASSIGN R1
IStr      	.ASSIGN R2
OStr	     	.ASSIGN R3
Res	    	.ASSIGN R4
Res_Count	.ASSIGN R5
SP		.ASSIGN R13

.nr_org 0x2000
	
	mov 	STACK_POINTER, 	SP
	st.w 	1000, 		-[SP]
	st.w 	0x10, 		-[SP]
	
	mov 	ROOT_ADDR, 	R0
	st.w 	0x0000, 	[R0]+
	st.w 	0x0006, 	[R0]+
	st.w 	0x000C, 	[R0]+
	
	st.w 	R0, 		[0x0200+TABLE_ADDR]
	st.w 	0x0A00, 	[R0]+
	st.w 	0x0001, 	[R0]+
	st.w 	0x0100, 	[R0]+
	
	st.w 	R0, 		[0x0220+TABLE_ADDR]
	st.w 	0x0C00, 	[R0]+
	st.w 	0x0001, 	[R0]+
	st.w 	0x0110, 	[R0]+
	
	st.w 	R0, 		-[SP]

	mov 	ISTREAM, 	IStr_Addr
	mov 	OSTREAM, 	OStr_Addr
	ld.b 	[IStr_Addr]+, 	Res
	mov 	0x10, 		Res_Count
start:	
	mov 	Res,		R7	
	ldin	[R7*+TABLE_ADDR], R6
	tst 	0xFFFF, 	R6
	bra.eq 	add_node
	call 	encode
	call 	shift_ostream
	ld.w 	[R6+2], 	R7			;get count of leaf, for increment tree function
	call 	increment_tree
	cmp 	(ISTREAM+1000), IStr_Addr
	ld.b 	[IStr_Addr]+, 	Res
	bra.n 	start
	bra 	finish
add_node:
	ld.w 	[TABLE_ADDR+0x220], R6
	call 	encode
	call 	shift_ostream
	mov 	0x8, 		R8			;8 bit symbols
	mov 	Res, 		R7
	call 	shift_ostream
	ld.w 	[SP]+, 		R6
	call 	insert_node
	st.w 	R6, 		-[SP]
	sub 	0x6, 		R6
	ld.w 	[R6+2], 	R7			;get count of leaf, for increment tree function
	call 	increment_tree
	cmp 	(ISTREAM+1000), IStr_Addr
	ld.b 	[IStr_Addr]+, 	Res
	bra.n start
	bra finish

	
.include "instr.asm"

finish:
	
	xor R12, R12

.END
	
	
	
	
	
	
	
	

