

	;Shifts the stream in the IStr register by the amount
	;given in R8. Uses the Res register as bit Reservoar,
	;Res_Count indicates the number of bits left in the
	;Reservoar
	
.start_profile shift_istream streams		
shift_istream: 
	sub 	R8, 		Res_Count		;Check if enough bits are available in reservoar
	bra.n 	get_packet				;If not get new packet
	sll 	R8, 		IStr			;Shift out bits according to R8 
	slr 	Res_Count, 	Res, 	R10		;Shift out bit from reservoar into R10
	or 	R10, 		IStr			;Mask in bits from reservoar
	sll 	Res_Count, 	R10			;Delete bits from reservoar
	xor 	R10, 		Res
	ret
.end_profile shift_istream
get_packet:
	add 	R8, 		Res_Count		;Calc bits left in reservoar
	sll 	Res_Count, 	IStr
	or 	Res, 		IStr
	ld.w 	[IStr_Addr]+, 	Res
	sub 	Res_Count, 	R8			;Calc bits left to shift
	mov 	0x10, 		Res_Count
	bra 	shift_istream
;---------------------------------------------------------------------------------	
	
.start_profile decode	
dec_stream:
;.start_profile	bfo12_dec_stream1	bfo12
	sll	1,		IStr,	R6
	slr 	14,		R6
	cmp	3,		R6
;.end_profile	bfo12_dec_stream1	
	bra.eq	char	
	sll	3,		IStr,	R7
	cmp	0,		R6
	bra.eq	len_2_bit
	cmp	1,		R6
	bra.eq	len_4_bit
	cmp	2,		R6
	bra.eq	len_7_bit
char:
	tst	0x8000,		IStr
	bra.eq	finish
.start_profile	bfo4_dec_stream3	bfo4
	sll	3,		IStr,	R7
	slr	8,		R7
.end_profile	bfo4_dec_stream3
	st.b	R7,		[OUT_PTR]+	
	mov 	11,		R8
	call	shift_istream
	bra	end_dec
len_2_bit
.start_profile	bfo10_dec_stream4	bfo10
	slr	14,		R7
	add	3,		R7
.end_profile	bfo10_dec_stream4
	mov 	5,		R8
	bra dist
len_4_bit
.start_profile	bfo10_dec_stream5	bfo10
	slr	12,		R7
	add	7,		R7
.end_profile	bfo10_dec_stream5
	mov	7,		R8
	bra	dist
len_7_bit
.start_profile	bfo10_dec_stream6	bfo10
	slr	9,		R7
	add	23,		R7
.end_profile	bfo10_dec_stream6
	mov	10,		R8
dist
	tst	0x8000,		IStr
	bra.ne	dist_10_bit
	call	shift_istream
	slr	8,		IStr,	R11
	mov	8,		R8
	bra	cont_dist
dist_10_bit
	call	shift_istream
	slr	6,		IStr,	R11
	mov	10,		R8
cont_dist:
	call	shift_istream
	sub	R11,		OUT_PTR,R11
	
dec_loop:
	ld.b	[R11]+,		R12
	st.b	R12,		[OUT_PTR]+
	sub	1,		R7
	bra.ne 	dec_loop
end_dec:
	ret
.end_profile decode

 
	
	
		
	
	