#define WANT_STREAM
#define WANT_TIME

#include "include.h"
#include "newran.h"
#include "tryrand.h"
#include <fstream.h>
#include <stdio.h>

#ifdef use_namespace
using namespace NEWRAN;
#endif

void write_ram_hex(char *fname, WORD *data, int length);

void main(int argc, char **argv)
{
  // time_lapse tl;      // measure program run time

	Random::Set(0.46875);

	WORD stat[1000];
	WORD samples[1000];

	char ascii_samples[1000];


	int j, i;
	int high = 0, low =1000, temp;

	for (j=0; j<atoi(argv[1]); j++) stat[j] = 0;

	/*ifstream input_text;
	input_text.open("text.txt",ifstream::binary, ifstream::in);

	input_text.get(ascii_samples,1000);
	for (i=0; i<1000; i++) {
		samples[i] = int(ascii_samples[i]);
		stat[samples[i]] ++;
		if(low > samples[i])
		   low = samples[i];
	   if(high < samples[i])
		   high = samples[i];
	}
	input_text.close();*/

   Real param = atof(argv[2]);
   //Gamma P(param);
   //Exponential P;
   //Poisson P(param);
   Pareto P(param);
   //Uniform P;

   
   /*for (i=0; i<atoi(argv[1]); i++) {
	   temp = (WORD)P.Next();
	   stat[temp] ++;
	   samples[i] = temp;
	   if(low > temp)
		   low = temp;
	   if(high < temp)
		   high = temp;
   }*/
	   

   ofstream outputFile;
   outputFile.open("prob.txt");

   for (j=low; j<high+1; j++) {
		outputFile << j << char(9) << stat[j] << char(9);
		for(i=0; i<stat[j]; i++)
			outputFile << "*";
		outputFile << "\n";
	   
   }

   //outputFile << '\n' <<'\n' <<'\n' << "PARAMETER: " << atof(argv[2]);

   outputFile.close();

   //write_ram_hex("samples_text.txt", samples, 1000);

   //write_ram_hex("samples.txt", samples, atoi(argv[1]));

   WORD mnp5_table[512];
   j=0;
   for (i=0; i<512; i+=2) {
	   mnp5_table[i] = 0;
	   j++;
	   mnp5_table[i+1] = j;
   }

   write_ram_hex("ram.hex", mnp5_table, 512);


   
}



void write_ram_hex(char *fname, WORD *data, int length) {

	ofstream out;
	out.open(fname);

	char *utdata = new char[length*4];
	int pos = 0;

	for (int i=0; i<length; i+=2) {
		pos += sprintf(utdata+pos, "%02X%02X\n\n", *(data+i), *(data+i+1));
	}

	out.write(utdata, pos);

	out.close();


}



