
LUT		.ASSIGN	0
INN_STREAM	.ASSIGN 512
END_INN_STREAM	.ASSIGN (INN_STREAM + 1000)

HASH_TABLE	.ASSIGN 2048
MATCH_TABLE	.ASSIGN 3000
OUT_STREAM	.ASSIGN 7500





SP		.ASSIGN R13
STREAM_PTR	.ASSIGN	R0
OUT_PTR		.ASSIGN R1
OUT_REG		.ASSIGN R3
OS_BCOUNT	.ASSIGN R2




.nr_org 0x4000

   mov 0, R0
   mov 0, R1
   mov 0, R2
	mov 0, R3
	mov 0, R4
	mov 0, R5
	mov 0, R6
	mov 0, R7
	mov 0, R8
	mov 0, R9
	mov 0, R10
	mov 0, R11
	mov 0, R12
	wrio R12, [0]
	wrio R12, [1]

setup:
	mov 	0x4000, 	SP
	mov 	OUT_STREAM, 	OUT_PTR
	st.w 	MATCH_TABLE, 	-[SP] 
	mov 	INN_STREAM, 	STREAM_PTR
	mov 	0x10, 		OS_BCOUNT

;.start_profile find_longest_match	
encode: 
	mov 	STREAM_PTR, 	R7
	call 	crc1
	st.w 	R8, 		-[SP]
.start_profile	sa3_encode1	shift_add3
	sll 	1, 		R8
	ld.w 	[R8+HASH_TABLE],R4
.end_profile	sa3_encode1
	xor 	R6, 		R6
	tst 	0xFFFF, 	R4
	bra.eq 	search_finished
match_loop:
	mov 	STREAM_PTR, 	R7
	ld.w 	[R4]+, 		R8
	call 	check_match
	cmp	R9,		R6
	bra.n 	longer_match
;.end_profile	brac_main1
cont_match_loop:
	ld.w 	[R4], 		R4
	tst 	0xFFFF, 	R4
	bra.ne 	match_loop
	ld.w 	[R5], 		R5				;load adress to mach
	cmp	0x3,		R6
	bra.ges search_finished
	xor 	R6, 		R6
	mov 	STREAM_PTR, 	R5
	bra 	search_finished
	
longer_match:
	mov 	R9, 		R6				;move literals to R6
	sub 	1, 		R4, 	R5			;move addr for matchtable to R5
	bra 	cont_match_loop
	
search_finished
	ld.w 	[SP]+, 		R9
;.end_profile find_longest_match
	ld.w 	[SP]+, 		R8
	mov 	STREAM_PTR, 	R7
	call 	add_match
	st.w 	R8, 		-[SP]
	call 	enc_stream
	cmp	0,		R6
	bra.ne	add_matches	
	cmp	END_INN_STREAM,	STREAM_PTR
	bra.n	encode
	bra 	finish
	
add_matches:
	sub	1,		R6
add_matches_loop:
	mov	STREAM_PTR,	R7
	call	crc1
	mov	R8,		R9
	ld.w 	[SP]+, 		R8
	mov 	STREAM_PTR, 	R7
	call	add_match
	st.w 	R8, 		-[SP]
	add	1,		STREAM_PTR
	sub	1,		R6
	bra.ne	add_matches_loop
	bra 	encode
	
	
	
.include "instr_enc.asm"

finish:
	mov	3,		R8
	mov	3,		R7
	call	shift_ostream
	xor	R7,		R7
	mov	16,		R8
	call	shift_ostream
	xor R12, R12
	  
.END	
