
	;Shifts the stream in the IStr register by the amount
	;given in R8. Uses the Res register as bit Reservoar,
	;Res_Count indicates the number of bits left in the
	;Reservoar
	
.start_profile shift_istream streams		
shift_istream: 
	sub R8, Res_Count		;Check if enough bits are available in reservoar
	bra.n get_packet		;If not get new packet
	sll R8, IStr			;Shift out bits according to R8 
	slr Res_Count, Res, R10		;Shift out bit from reservoar into R10
	or R10, IStr			;Mask in bits from reservoar
	sll Res_Count, R10		;Delete bits from reservoar
	xor R10, Res	
	ret
.end_profile shift_istream
get_packet:
	add R8, Res_Count		;Calc bits left in reservoar
	sll Res_Count, IStr
	or Res, IStr
	ld.w [IStr_Addr]+, Res
	sub Res_Count, R8		;Calc bits left to shift
	mov 0x10, Res_Count
	bra shift_istream
	
;------------------------------------------------------------------------------
	
	
	;data in IStr, reulting acc count in R7, count in R8
	;R7 must be prepared before function call

.start_profile clz1	clz1	
clz1:
	xor R8, R8
	tst 0xFFFF, IStr
	bra.eq all_zeroes
	sub 0x1, R8
	mov IStr, R11
search:
	add 0x1, R8
	sll 0x1, R11
	bra.ltu search
	add R8, R7
clz_ret
	ret
.end_profile clz1
all_zeroes:
	mov 0x10, R8
	add 0x10, R7
	bra clz_ret
;------------------------------------------------------------------------------
	;data in R12, reulting count in R11
	
.start_profile clz2 clz1	
clz2:
	xor R11, R11
	tst 0xFFFF, R12
	bra.eq all_zeroes_clz2
	sub 0x1, R11
search_clz2:
	add 0x1, R11
	sll 0x1, R12
	bra.ltu search_clz2
clz2_ret
	ret
.end_profile clz2
all_zeroes_clz2:
	mov 0x10, R11
	bra clz2_ret
	
