library ieee;
use ieee.std_logic_1164.all;
use IEEE.std_logic_arith.all;

use	work.std_ulogic_arith.all;
use work.std_ulogic_unsigned.all;

use	work.nb_pkg.all;

entity nb_shift is 
	port (
		-- Inputs
		RS				: in data_word_type;
		RS2				: in data_word_type;
                STREAM                          : in data_word_type;
		
		SHIFT_CONTROL	: in shift_control_rec;
		
		SR				: in sr_type;
		
		-- Outputs
		SHIFT_RES		: out data_word_type;
		SHIFT_SR		: out sr_nibble_type
	);

end nb_shift;
